<?php
//Portions of this script require php 5+ (scandir), others require 5.2.0+ (json_encode) use PECL to work around if needed

/******************CONFIGURATION*******************/
$JSONFolderName='json'; //The name of the folder where the JSON files live
$sep='/';//Unix folder seperator use '\' for Windows servers

/*******************FUNCTIONS**********************/

//Make an array of all of the file names in our JSON folder
function makeJSONFileNameArray($JSONPath){
	$JSONFileNameArray=scandir($JSONPath);//scandir does all the heavy lifting
	//Get rid of the . and .. paths
	unset($JSONFileNameArray[array_search('.', $JSONFileNameArray)]); // current dir
	unset($JSONFileNameArray[array_search('..', $JSONFileNameArray)]);  // dir above current
	$JSONFileNameArray=array_values($JSONFileNameArray);  // reenumberate the array so you start at 0, not two
	return $JSONFileNameArray;
}

function readJSONFile($JSONfileNameAndPath){
	$fileHandle = fopen($JSONfileNameAndPath, "r");
	$JSONData = fread($fileHandle, filesize($JSONfileNameAndPath));
	fclose($fileHandle);
	return json_decode($JSONData, TRUE);
}

/*********************Init**************************/
//The name of the script
$basename=basename($_SERVER['PHP_SELF']); //If worried about security, this could be hard coded to index.php (I think it should be OK as is though)

//Get the full path of where our scipt is running
if(substr($_SERVER['DOCUMENT_ROOT'], -1)==$sep) $drLen=(strlen($_SERVER['DOCUMENT_ROOT'])-1);//Some servers report DOCUMENT_ROOT with a trailing slash some don't, so we plan for both...
else $drLen=strlen($_SERVER['DOCUMENT_ROOT']);
$JSONPath=substr($_SERVER['DOCUMENT_ROOT'],0 , $drLen).dirname($_SERVER['PHP_SELF']).$sep.$JSONFolderName;//Use that to build our JSON path

//Load the list JSON filename array
$JSONFileNameArray=makeJSONFileNameArray($JSONPath);

/****************OVERLAY HELPERS*********************/
//Dump the json for the selected author
if(ctype_digit($_GET['index'])&&($_GET['index']>=0 && $_GET['index']<=1000000)){//Super simple validation
	$fileHandle = fopen($JSONPath.$sep.$JSONFileNameArray[$_GET['index']], "r");
	$JSONData = fread($fileHandle, filesize($JSONPath.$sep.$JSONFileNameArray[$_GET['index']]));
	fclose($fileHandle);
	if(($_GET['ajax']=='true')){//Print json for AJAX and die
		die($JSONData);
	}else{//Non AJAX (build HTML in PHP)
		$dataArray=json_decode($JSONData, TRUE);
		$overlayHTML = ''; //Rexux of JS code
		$overlayHTML .= '<div id="author_info">';
		$overlayHTML .= '<img src=" ' . ($dataArray['photo']['url']) .'" alt="'.($dataArray['photo']['alt']).'"> </img>'."\n";
		$overlayHTML .= '<h1>';
		$overlayHTML .= '<span>'.($dataArray["first_name"]).'</span> '; //note space at end of line - appears between first and last name
		$overlayHTML .= '<span>'.($dataArray["last_name"]).'</span>';
		$overlayHTML .= '</h1>'."\n";
		$overlayHTML .= '<h2>Book</h2>';
		$overlayHTML .= '<h3>' . $dataArray['book']['title'] . '</h3>'."\n";
		$overlayHTML .= '<p class="description"><strong><em>' . $dataArray['book']['description'] . '</em></strong></p>'."\n";
			if ($dataArray['book']['co-author']) {
				$overlayHTML .= '<p class="description">Co-author: ' . $dataArray['book']['co-author'] . '</p>'."\n";
			}
		$overlayHTML .= '<p class="description"><a href="' . $dataArray['book']['buy_link'] . '" target="_blank">';
		$overlayHTML .= 'Buy this book</a></p>'."\n";
		$overlayHTML .= '<h2>Bio</h2>';	
		$bio = $dataArray['bio'];
		foreach($bio as $bioPara){
			$overlayHTML .= '<p class="bio">' . $bioPara['para'] . '</p>'."\n";
		}
		$overlayHTML.= '</div>';
	}
}


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	
<head>
<title>jQuery Tools Carousel Demo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" href="css/carousel.css" type="text/css" />
<link rel="stylesheet" type="text/css" href="css/_overlay.css" />

<script src="jquery/jquery-1.3.2.js" type="text/javascript"></script>
<!-- this file includes all tools together with the jQuery library -->
<script src="jquery/jquery.tools.min.js" type="text/javascript"></script>
<!-- mousewheel support -->
<script src="jquery/jquery.mousewheel.js" type="text/javascript"></script>
<!-- styling -->
<script src="jquery/jquery-corners-0.3/jquery.corners.min.js" type="text/javascript"></script>
<script type="text/javascript">
<!--
$(document).ready(function(){//Execute your scripts when DOM is ready.
	// rounded corners
	$('.rounded').corners('12px'); // adds rounded corners to all elements with 'rounded' class
	
	$('#overlay_content_noJS').css('display','none'); // hides the div used for content if JS is not available
	$("div.scrollable").css("overflow-x","hidden"); // hides the scrollbar if JS is available
	$("div.scrollable").css("height","154px");	//reduces the height if the scrollbar is not present
	$("a.prev, a.next").css("display","block"); // shows the arrow controls if JS is present
    // initialize scrollable  
    $("div.scrollable").scrollable({ 
        size: 3, // the number of visible thumbs - you must alter the widths of the container in the css if you chnange this
        items: '#thumbs',   // the scolling elements
        hoverClass: 'hover' // the class added when the mouse hovers
    });     
	
	//Initialize the overlay
	var api = $("div.overlay").overlay({oneInstance: false, api: true, onClose:function () {
		$('#author_info').remove();
		}
	}); 

	$('.thumbContainer').bind("click", function(){ //Capture clicks on the thumbnail container
		var authorIndex=$(this).children('div.thumb_inner').children('a').attr('rel'); //Get the index of the author out of links rel attribute
		$.getJSON("?index="+authorIndex+"&ajax=true", function(JSONData){
			tags = ' '; //empty string
			tags += '<div id="author_info">';
			tags += '<img src=" ' + (JSONData['photo']['url']) +'" alt="'+(JSONData['photo']['alt'])+'"> </img>\n';
			tags += '<h1>';
			tags += '<span>'+(JSONData["first_name"])+'</span> '; //note space at end of line - appers between first and last name
			tags += '<span>'+(JSONData["last_name"])+'</span>';
			tags += '</h1>\n';
			tags += '<h2>Book</h2>';


				tags += '<h3>' + JSONData['book']['title'] + '</h3>\n';
				tags += '<p class="description"><strong><em>' + JSONData['book']['description'] + '</em></strong></p>\n';
				if (JSONData['book']['co-author']) {
				tags += '<p class="description">Co-author: ' + JSONData['book']['co-author'] + '</p>\n';
				}
				
				tags += '<p class="description"><a href="' + JSONData['book']['buy_link'] + '" target="_blank">';
				tags += 'Buy this book</a></p>\n';

			tags += '<h2>Bio</h2>';	
			var bio = JSONData['bio'];
			for(var i = 0; i < bio.length; i++){
				tags += '<p class="bio">' + bio[i]['para'] + '</p>\n';
			}
			tags += '</div>';
			//insert the assembled html into the page
			$(".close").html('');
			$(".close").after(tags);

		});
		api.load();//Popup the overlay
		return false;
	});
});


-->
</script>
<style type="text/css">
/*Hack to set the width of the container to the width of the elements*/
#thumbs {
	width: <?php print (count($JSONFileNameArray)*100).'px';?>;
}
</style>
</head>
<body>
<?php  // print "<pre>"; print_r(readJSONFile($JSONPath.$sep.$JSONFileNameArray[11])); print "<pre>"; // uncomment to view a json file ?> 
<?php  // print "<pre>"; print_r($JSONPath); print "<pre>"; // uncomment to view file path ?>
<div id="wrapper">
<div id="people_display"  class="rounded clearfix">
<div id="title"><h2>Meet the Authors</h2></div>

<div id="carousel_wrapper" class="rounded clearfix">
<!--div class="navi"></div-->
    <!-- prev link -->

    

<!-- root element for scrollable -->
<div class="scrollable">
	<div id="thumbs" class="">
		<?php
		foreach ($JSONFileNameArray as $index => $fileName){
			$authorInfo=readJSONFile($JSONPath.$sep.$fileName);
			// here we build the content for the carousel
			print '
		<div class="thumbContainer">
			<div class="thumb_inner">
				<!--Link Overridden By Javascript-->
				<a href="?index='.$index.'" class="linkToSite" rel="'.$index.'"> 
					<img class="person_pic" alt="'.$authorInfo['photo']['alt'].'" src="'.$authorInfo['photo']['url'].'" />
				</a>
				<h3 class="person_name">
				<a href="?index='.$index.'" class="linkToSite" rel="'.$index.'"> 
				'.$authorInfo['first_name'].'<br />'.$authorInfo['last_name'].'
				</a>
				</h3>
			</div>
			
		</div>
		';
		}?>	
	</div>
</div>
<a class="prev"></a>
    <!-- next link -->
    <a class="next"></a>
</div><!--end carousel wrapper -->
</div><!-- end people_display -->

<div class="overlay" id="overlay_content"></div><!-- end overlay_content -->

<?php // insert a div and the requested content if JS is not available - PHP is displaying the content
	if ($overlayHTML) {print '<div id="overlay_content_noJS">' .$overlayHTML . '</div>';} 
?><!-- end overlay_content_noJS -->



<div id="footer" class="rounded">
	<div id="footer_inner" >
		
		<p><em>An example from the book <a href="http://www.scriptinwithajax.com">Scriptin' with JavaScript and Ajax</a> by Charles Wyke-Smith</em></p>
	</div>
</div>




</div><!-- END WRAPPER -->
</body>
</html>
