// JavaScript Document
// Scriptin' helper functions
//alert ("helper file loaded!");

// THE HELPER FUNCTIONS INDEX
// addLoadEvent(func) - allows multiple onload events
// addEvent( obj, type, fn ) - add event listener
// removeEvent( obj, type, fn ) - removes event listener
// getElementsByClass(node,searchClass,tag) -- finds all elements (optional tag type) with searchClass within node - use * for entire doc
// cleanNodes(id) - removes white space nodes from all tags within element with id
// equal columns - sets all elements with class 'equal' to height of longest
// getStyles - gets the rendered style (e.g height) of an element

// THE HELPER FUNCTIONS 
// use addLoadEvent(funcName);
//this does not interfere with other onLoads - nice
function addLoadEvent(func) {
var oldonload = window.onload;
if (typeof window.onload != 'function') { 
	window.onload = func; 
	} else { 
	window.onload = function() { 
		oldonload(); func(); 
		}
	}
}

//john resig's cross-browser event listener add/remove function
function addEvent( obj, type, fn ) {
  if ( obj.attachEvent ) {
    obj['e'+type+fn] = fn;
    obj[type+fn] = function(){obj['e'+type+fn]( window.event );}
    obj.attachEvent( 'on'+type, obj[type+fn] );
  } else
    obj.addEventListener( type, fn, false );
}
function removeEvent( obj, type, fn ) {
  if ( obj.detachEvent ) {
    obj.detachEvent( 'on'+type, obj[type+fn] );
    obj[type+fn] = null;
  } else
    obj.removeEventListener( type, fn, false );
}

//dustin diaz' getElementByClass
// optional: node = document or use getElementById("idName") and pass that
// req: searchClass - the name of the class you are looking for as a string
// optional: limit search to just a particular type of tag
//as in 
/*function showFoo() {
var el = getElementsByClass(document,'foo','*');
alert(el.length);
} */
function getElementsByClass(node,searchClass,tag) {
var classElements = new Array();
var els = node.getElementsByTagName(tag); // use "*" for all elements
var elsLen = els.length;
var pattern = new RegExp("\\b"+searchClass+"\\b");
	for (i = 0, j = 0; i < elsLen; i++) {
 		if ( pattern.test(els[i].className) ) {
 			classElements[j] = els[i];
 			j++;
 		}
	}
	return classElements;
}

//Chris Heilmann's "get rid of child whitespace nodes" script
function cleanChildNodes(id){
  // get the element with the id provided
  var x = document.getElementById(id);
  // test if the element exists
  if(x){
    // regular Expression testing if a string is only whitespace
    var reg = /s*/mg;
    // loop over all childNodes of the element
    for(var i=0;x.childNodes[i];i++){
      // if the current item only consists of whitespace
      var current = x.childNodes[i];
      if(reg.test(current.nodeValue)){
      //  remove it
        current.parentNode.removeChild(current);
      }
      // there is no need to check for the node type
      // as element nodes have a nodeValue of null
    }
  }
}


// This function inserts newNode after referenceNode
//found at http://www.netlobo.com/javascript-insertbefore.html
function insertAfter( referenceNode, newNode ) {
    referenceNode.parentNode.insertBefore( newNode, referenceNode.nextSibling );
}

//Chris Heilmann's class management script
// add, remove, swap and check for classes on an element
// a = action to take - can be "add", "remove", swap", or "check" - string
// o = object
// c1 = class to use - string
// c2 = class to swap out - string - optional 
function cssjs(a,o,c1,c2){
		switch (a){
			case 'swap':
				o.className=!DOMhelp.cssjs('check',o,c1)?o.className.replace(c2,c1):o.className.replace(c1,c2);
			break;
			case 'add':
				if(!DOMhelp.cssjs('check',o,c1)){o.className+=o.className?' '+c1:c1;}
			break;
			case 'remove':
				var rep=o.className.match(' '+c1)?' '+c1:c1;
				o.className=o.className.replace(rep,'');
			break;
			case 'check':
				var found=false;
				var temparray=o.className.split(' ');
				for(var i=0;i<temparray.length;i++){
					if(temparray[i]==c1){found=true;}
				}
				return found;
			break;
		}
	}
//Chris Heilmann's cancel click - prevent href from triggering when click is handled by JS
function cancelClick(e){
       if (window.event){
           window.event.cancelBubble = true;
           window.event.returnValue = false;
       }
       if (e && e.stopPropagation && e.preventDefault){
           e.stopPropagation();
           e.preventDefault();
       }
   }
// found at http://www.tedspence.com/index.php?entry=entry080626-093659
function IsNumeric(sText) {
var ValidChars = "0123456789.";
for (i = 0; i < sText.length; i++) {
	if (ValidChars.indexOf(sText.charAt(i)) == -1) {
		return false;
	}
}
	return true;
}

//collects all the page's divs with the class 'equal' and sets then to the same height 
//requires getStyle(), getElementByClass()
// by Charles Wyke-Smith www.scriptinwithajax.com
function equalizeColumns() {
if (!document.getElementsByTagName) return false;
	var theDom=document.getElementsByTagName('body')
	var elDivs = getElementsByClass(theDom[0], "equal" , "*");
	if (elDivs.length>0) {
		var colHeightArray= [];
		for (var i=0; i < elDivs.length; i++) { 
			var	thisHeight=getStyle(elDivs[i], "height"); // obtains computed height of each col
			colHeightArray[i-1]=(parseInt(thisHeight));  // puts each col's height into the array (array starts at 0 not 1)	
			}
		colHeightArray.sort(function(a,b){return b - a}) //sorts an array high to low - use {return a - b} for low to high
		var maxHeight = (colHeightArray[0]);
		for (var i=0; i < elDivs.length; i++) {
			elDivs[i].style.height=(maxHeight+"px");
		}
	}
}

//Robert Nyman's (robertnyman.com) getStyle function - get the rendered style (width, height, etc. of a rendered element)
// length units are returned in format 100px, so use (parseInt(returnedResult)) in your code if you want an integer
function getStyle(oElm, strCssRule){
	var strValue = "";
	if(document.defaultView && document.defaultView.getComputedStyle){
		strValue = document.defaultView.getComputedStyle(oElm, "").getPropertyValue(strCssRule);
	}
	else if(oElm.currentStyle){
		strCssRule = strCssRule.replace(/\-(\w)/g, function (strMatch, p1){
			return p1.toUpperCase();
		});
		strValue = oElm.currentStyle[strCssRule];
	}
	return strValue;
}